#!/usr/bin/python

import sys
import gzip
import cStringIO

# installs english-arab dictionary "arabeyes"
# to dictionary uses the following format:
#   ....
#   msgid "english"
#   msgstr "arab"
#   
#   msgid "english"
#   msgstr "arab"
#   ....
# the dictionary is gzipped and utf-8 encoded.

# parse command-line arguments
sourceType = sys.argv[1]
source = sys.argv[2]
targetFile = sys.argv[3]

if sourceType == 'download':
	import urllib

try:
	if sourceType == 'download':
		print "Opening URL %s..." % source
		f = urllib.urlopen(source)
	else:
		print "Opening local file %s..." % source
		f = open(source, 'r')
	print "  done"
	
	print "Reading data..."
	data = f.read()
	print "  done"
	f.close()
except:
	print "error while retrieving data from %s:" % source
	print sys.exc_info()[0]
	sys.exit(1)

try:
	print "Decompressing and decoding (utf8) data..."
	data = unicode(gzip.GzipFile(None, "r", 0, cStringIO.StringIO(data)).read(), 'utf8')
	print "  done"
except:
	print "error while decompressing data:"
	print sys.exc_info()[0]
	sys.exit(1)

try:
	print "Parsing and writing data to local file %s (utf-8)..." % targetFile
	f = open(targetFile, 'w')
	readArab = False
	msgidLength = len("msgid \"")
	msgstrLength = len("msgstr \"")
	lines = data.splitlines()
	
	for line in lines:
		if line.startswith("msgid"):
			english = line[msgidLength:-1]
			readArab = True
		elif readArab:
			readArab = False
			if 	line.startswith("msgstr"):
				arab = line[msgstrLength:-1]

				line = "%s::%s\n" % (english, arab)
				f.write(line.encode("utf8"))
		else:
			continue

	f.close()
	print "  done"
except:
	print "error while writing data to %s:" % targetFile
	print sys.exc_info()[0]
	sys.exit(1)

sys.exit(0)
