#!/usr/bin/python

import sys
import cStringIO
import zipfile

# installs CEDICT: Chinese - English dictionary.
# the file comes as zip-archive which contains a file named cedict_ts.u8. This file holds the records in the
# following format:
#    CHINESE [pinyin] /English definition 1/English definition 2/.../


# parse command-line arguments
sourceType = sys.argv[1]
source = sys.argv[2]
targetFile = sys.argv[3]

if sourceType == 'download':
	import urllib

try:
	if sourceType == 'download':
		print "Opening URL %s..." % source
		f = urllib.urlopen(source)
	else:
		print "Opening local file %s..." % source
		f = open(source, 'r')
	print "  done"
	print "Reading data (zip-file)..."
	data = f.read()
	print "  done"
	f.close()
except:
	print "error while retrieving data from %s:" % source
	print sys.exc_info()[0]
	sys.exit(1)

# data now contains the bytes of the zip-file
try:
	print "Decompressing data..."
	data = unicode(zipfile.ZipFile(cStringIO.StringIO(data), "r").read("cedict_ts.u8"), "utf8")
	print "  done"
except:
	print "error while decompressing data:"
	print sys.exc_info()[0]
	sys.exit(1)

# data now contains the dictionary-file => parse it
try:
	print "Parsing and writing data to local file %s (utf-8)..." % targetFile
	f = open(targetFile, 'w')
	lines = data.splitlines()
	for line in lines:
		if line.startswith("#"):
			continue
			
		components = line.split("/")		
		chinese = components[0].strip()
		english = "; ".join(components[1:-1])
		line = "%s::%s\n" % (chinese, english)
		f.write(line.encode("utf8"))

	f.close()
	print "  done"
except:
	print "error while writing data to %s:" % targetFile
	print sys.exc_info()[0]
	sys.exit(1)


sys.exit(0)
