#!/usr/bin/python

import sys

# installs spanish-german dictionary by Zeno Gantner
# the dictionary already has ding-format but its encoding is iso-8859-1; this needs to be converted to utf-8

# parse command-line arguments
sourceType = sys.argv[1]
source = sys.argv[2]
targetFile = sys.argv[3]

if sourceType == 'download':
	import urllib

try:
	if sourceType == 'download':
		print "Opening URL %s..." % source
		f = urllib.urlopen(source)
	else:
		print "Opening local file %s..." % source
		f = open(source, 'r')
	print "  done"
	print "Reading data (iso-8859-1)..."
	data = unicode(f.read(), 'iso-8859-1')
	print "  done"
	f.close()
except:
	print "error while retrieving data from %s:" % source
	print sys.exc_info()[0]
	sys.exit(1)

# here we can assume that data holds the contents of the dictionary-file
try:
	print "Writing data to local file %s (utf-8)..." % targetFile
	f = open(targetFile, 'w')
	f.write(data.encode('utf8'))
	f.close()
	print "  done"
except:
	print "error while writing data to %s:" % targetFile
	print sys.exc_info()[0]
	sys.exit(1)


sys.exit(0)
