#!/usr/bin/python

import sys
import cStringIO
import gzip

# installs EDICT: Japanese - English dictionary.
# the file comes as gz-archive. its contents already is utf-8 encoded and in the
# correct (ding) format.


# parse command-line arguments
sourceType = sys.argv[1]
source = sys.argv[2]
targetFile = sys.argv[3]

if sourceType == 'download':
	import urllib

try:
	if sourceType == 'download':
		print "Opening URL %s..." % source
		f = urllib.urlopen(source)
	else:
		print "Opening local file %s..." % source
		f = open(source, 'r')
	print "  done"
	print "Reading data..."
	data = f.read()
	print "  done"
	f.close()
except:
	print "error while retrieving data from %s:" % source
	print sys.exc_info()[0]
	sys.exit(1)

# data now contains the bytes of the gz-file
try:
	print "Decompressing data..."
	data = gzip.GzipFile(None, "r", 0, cStringIO.StringIO(data)).read()
	print "  done"
except:
	print "error while decompressing data:"
	print sys.exc_info()[0]
	sys.exit(1)

try:
	# here we can assume that data holds the contents of the dictionary-file
	print "Writing data to local file %s..." % targetFile
	f = open(targetFile, 'w')
	f.write(data)
	f.close()
	print "  done"
except:
	print "error while writing data to %s:" % targetFile
	print sys.exc_info()[0]
	sys.exit(1)

sys.exit(0)
