#!/usr/bin/perl -w

use Encode;

$url = $ARGV[0];
$search =  $ARGV[1];

$url =~ s/%s%/$search/;


# use curl to retrieve the site (silent but show error messages)
open(WEBIN, "curl '$url' -s -S 2>&1 |") or die("fehler bei aufruf von curl");

while ($line = <WEBIN>) {
	chomp($line);
	
	# leo uses iso-8859-15 encoding
	$line = decode("iso-8859-15", $line);
	
	# curl returned with error (indicated by error-message beginnning with "curl")
	if ($line =~ /curl/i) {
		print $line;
		exit 2;
	}
	
	if ($line =~ /<table cellpadding=0 cellspacing=0 width="100%" id="results" border=1>(.+)<\/table>/i) {
		my @rows = split(/<tr/i, $1);
		
		# skip first two rows containing language-names (first row) and number
		# of hits (second row) and the "artificial" row before the first <tr>
		shift(@rows);
		shift(@rows);
		shift(@rows);

		# for all others: further processing		
		foreach $row (@rows) {
		
			# split columns
			my @items = split(/<td/i, $row);
			shift(@items);	# remove the "artificial" column in front of the first <td>
			
			# only one column -> category name
			if ($#items == 0) {
				$category = stripHTML("<td " . $items[0]);
				# at the moment we treat categories provided by leo as comments since we've
				# implemented our own categorization-system.
				print encode("utf8", "#" . $category . "\n");
			}
			
			# several columns -> translation entry
			else {
				$lang1 = stripHTML("<td" . $items[1]);
				$lang2 = stripHTML("<td" . $items[3]);
				
				print encode("utf8", $lang1 . "::" . $lang2 . "\n");
			}
		}
		
		# now look for orthographically similar words
#		if (($line =~ /Orthographically similar words(.+)Orthographically similar words(.+)/i) ||
#			($line =~ /Orthographisch .hnliche W.rter(.+)Orthographisch .hnliche W.rter(.+)/i))
#		  {
			
		  
#			$str1 = stripHTML($1);
#			$str2 = stripHTML($2);
		
				
#			my @suggestions1 = split(/\s/i, $str1);
#			my @suggestions2 = split(/\s/i, $str2);
			
			# first "suggestion" is in fact the language (German or English):
#			shift(@suggestions1);
#			shift(@suggestions1);
			
#			foreach $suggestion1 (@suggestions1) {
#				print encode("utf8", "!1 $suggestion1\n");
#			}
#			foreach $suggestion2 (@suggestions2) {
#				print encode("utf8", "!2 $suggestion2\n");
#			}

#		}
		
	}
}

close (WEBIN);



# remove html-tags and non-breaking spaces
# from the parameter
sub stripHTML {
	my $str = shift;

	$str =~ s/<[^>]*>//g;
	$str =~ s/\&nbsp;//ig;
	$str =~ s/\&ndash;//ig;
	
	# trim string as well
	$str =~ s/^\s+//;
	$str =~ s/\s+$//;
	
	return $str;
}

